#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int K = 18;
const int N = 1 << K;
const int MOD = 998244353;
const ll INF = 8e18;

struct Edge {
    int u1, u2, d1, d2;

    int go(int v) {
        return v ^ u1 ^ u2;
    }
};

namespace solve1 {
    vector<Edge> ed;
    vector<int> e[N];
    int ped[N];
    int p[N][K], h[N];
    ll dist[N];

    int lca(int u, int v) {
        if (h[u] < h[v]) swap(u, v);
        for (int i = 0; i < K; i++) if ((h[u] - h[v]) & (1 << i)) u = p[u][i];
        if (u == v) return u;
        for (int i = K - 1; i >= 0; i--) {
            if (p[u][i] != p[v][i]) {
                u = p[u][i];
                v = p[v][i];
            }
        }
        return p[u][0];
    }

    ll d(int u, int v) {
        int w = lca(u, v);
        return dist[u] + dist[v] - 2 * dist[w];
    }

    void dfs1(int v, int pr, int ch, ll cdist) {
        ped[v] = pr;
        p[v][0] = pr == -1 ? v : ed[pr].go(v);
        for (int i = 1; i < K; i++) p[v][i] = p[p[v][i - 1]][i - 1];
        dist[v] = cdist;
        h[v] = ch;

        for (int id : e[v]) {
            if (id == pr) continue;
            dfs1(ed[id].go(v), id, ch + 1, cdist + ed[id].d1);
        }
    }

    ll period;
    ll fix(const ll x) {
        return (x % period + period) % period;
    }

    struct segtree {
        int n, N;
        vector<vector<ll> > t;

        segtree() {}
        segtree(int _n) {
            n = _n;
            N = 1;
            while (N < n) N <<= 1;
            t.assign(2 * N, vector<ll>(2, -INF));
        }

        void upd(int x, int tp, ll y) {
            x += N;
            t[x][tp] = y;
            t[x][tp ^ 1] = -INF;
            while (x > 1) {
                x >>= 1;
                t[x][0] = max(t[x * 2][0], t[x * 2 + 1][0]);
                t[x][1] = max(t[x * 2][1], t[x * 2 + 1][1]);
            }
        }

        int getLeft(int v, int tl, int tr, int l, int r, const vector<ll> &need) {
            if (l > r) return n;
            if (t[v][0] < need[0] && t[v][1] < need[1]) return n;
            if (tl == tr) {
                return tl;
            }
            int tm = (tl + tr) >> 1;
            int res = getLeft(v * 2, tl, tm, l, min(r, tm), need);
            if (res == n) res = getLeft(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, need);
            return res;
        }

        int getLeft(int l, int r, vector<ll> need) {
            return getLeft(1, 0, N - 1, l, r, need);
        }
    };
    vector<ll> start;
    struct str {
        struct Data {
            ll start;
            int type;
            ll difN;

            ll getStart(ll pref, ll clen) const {
                ll res = fix(start + type * pref + (type == -1) * -clen);
                return res;
            }

            ll getEnd(ll pref, ll clen) const {
                return fix(getStart(pref, clen) + clen);
            }
        };

        int k;
        vector<Data> vct;
        set<int> st;
        segtree tr;

        str(int _k) {
            k = _k;
            vct.resize(k);
            tr = segtree(k);
        }

        void updDif(int i, int ni) {
            vct[i].difN = (vct[ni].start - vct[i].start);
            if (i > ni) vct[i].difN += period;
            tr.upd(i, vct[i].type == 1, vct[i].difN);
        }

        void add(int type, ll start, int id) {
            vct[id] = Data({start, type, 0});
            st.insert(id);

            auto it = st.lower_bound(id);
            int pi;
            if (it == st.begin()) pi = *(--st.end());
            else pi = *--it;
            int ni;
            it = ++st.lower_bound(id);
            if (it == st.end()) ni = *st.begin();
            else ni = *it;

            updDif(pi, id);
            updDif(id, ni);
        }

        void del(int type, ll start, int id) {
            vct[id].type = 0;
            auto it = st.lower_bound(id);
            int pi;
            if (it == st.begin()) pi = *(--st.end());
            else pi = *--it;
            int ni;
            it = ++st.lower_bound(id);
            if (it == st.end()) ni = *st.begin();
            else ni = *it;
            st.erase(id);
            tr.upd(id, 0, -INF);

            updDif(pi, ni);
        }

        ll findFirst(ll cur, ll pref, ll clen, ll need) {
            if (st.empty()) return cur;

            int ii = lower_bound(start.begin(), start.end(), cur) - start.begin();
            auto it = st.lower_bound(ii);
            if (it != st.begin()) it--;
            int cnt = 0, i = -1;
            while (it != st.end()) {
                cnt++;
                int ci = *it;
                if (vct[ci].getStart(pref, clen) >= cur) {
                    i = ci;
                    break;
                }
                it++;
            }
            assert(cnt <= 2);
            if (i == -1) i = *st.begin();

            it = st.lower_bound(i);
            int pi = it == st.begin() ? *(--st.end()) : *--it;
            if ((vct[pi].getStart(pref, clen) <= vct[pi].getEnd(pref, clen) && vct[pi].getStart(pref, clen) <= cur && cur <= vct[pi].getEnd(pref, clen)) ||
                (vct[pi].getStart(pref, clen) > vct[pi].getEnd(pref, clen) && (vct[pi].getStart(pref, clen) <= cur || vct[pi].getEnd(pref, clen) >= cur))) {
                cur = vct[pi].getEnd(pref, clen);
            }

            if (fix(vct[i].getStart(pref, clen) - cur) >= need) return cur;

            int si = i;
            /*do {
                if (vct[i].type != 0) {
                    ll haveTime = (vct[i].difN - 2 * vct[i].type * pref - (vct[i].type == 1) * 2 * clen);
                    assert(haveTime >= 0);
                    if (haveTime >= need) return vct[i].getEnd(pref, clen);
                }
                i = (i + 1) % vct.size();
            } while (i != si);*/
            vector<ll> cneed(2);
            cneed[1] = need + 2 * pref + 2 * clen;
            cneed[0] = need - 2 * pref;
            int t = tr.getLeft(si, k - 1, cneed);
            if (t == k) t = tr.getLeft(0, k - 1, cneed);
            if (t == k) return -1;
            return vct[t].getEnd(pref, clen);
        }
    };

    int solve(int n, vector<Edge> _ed, vector<int> x, int s, int f) {
        ed = _ed;
        int k = x.size();
        for (int i = 0; i < n; i++) {
            e[i].clear();
        }
        for (int i = 0; i < n - 1; i++) {
            int u1 = ed[i].u1;
            int u2 = ed[i].u2;
            e[u1].push_back(i);
            e[u2].push_back(i);
        }

        dfs1(s, -1, 0, 0);

        int m = h[f] + 1;

        vector<int> lens;
        for (int v = f; v != s; v = p[v][0]) lens.push_back(ed[ped[v]].d2);
        reverse(lens.begin(), lens.end());

        vector<int> vert(m);
        vert[m - 1] = f;
        for (int i = m - 2; i >= 0; i--) vert[i] = p[vert[i + 1]][0];

        vector<int> y(k);
        for (int i = 0; i < k; i++) {
            y[i] = h[lca(x[i], f)];
        }

        start.resize(k);
        vector<char> ff(k);
        period = 0;
        for (int i = 0; i < k; i++) {
            ll o = d(x[i], vert[y[i]]);
            start[i] = period + o;
            ff[i] = y[i] != y[(i + 1) % k];
            period += d(x[i], x[(i + 1) % k]);
        }
        int ck = 0;
        for (int i = 0; i < k; i++) {
            if (ff[i]) {
                y[ck] = y[i];
                start[ck] = start[i];
                ck++;
            }
        }
        start.resize(ck);
        k = ck;

        vector<ll> pref(m);
        for (int i = 1; i < m; i++) pref[i] = pref[i - 1] + dist[vert[i]] - dist[vert[i - 1]];

        vector<vector<int> > vct(m);
        for (int i = 0; i < k; i++) vct[y[i]].push_back(i);

        int ans = 0;
        ll cur = 0;
        str eb = str(k);
        bool fail = 0;
        for (int i = 0; i < m - 1; i++) {
            for (int j : vct[i]) {
                int jp = (j - 1 + k) % k;
                int jn = (j + 1) % k;
                if (y[jn] > y[j] && y[jp] > y[j]) {
                    eb.add(1, start[j] - pref[y[j]], j);
                    eb.add(-1, start[jp] + pref[y[jp]], jp);
                }
                else if (y[jn] < y[j] && y[jp] < y[j]) {
                    eb.del(1, start[jp] - pref[y[jp]], jp);
                    eb.del(-1, start[j] + pref[y[j]], j);
                }
                else if (y[jn] < y[j] && y[jp] > y[j]) {
                    eb.del(-1, start[j] + pref[y[j]], j);
                    eb.add(-1, start[jp] + pref[y[jp]], jp);
                }
                else {
                    eb.del(1, start[jp] - pref[y[jp]], jp);
                    eb.add(1, start[j] - pref[y[j]], j);
                }
            }
            ll o = eb.findFirst(cur, pref[i], pref[i + 1] - pref[i], lens[i]);
            if (o == -1) {
                fail = 1;
                break;
            }
            if (o < cur) ans = (ans + period) % MOD;
            cur = o;
            cur += lens[i];
            if (cur >= period) {
                ans = (ans + cur / period * period) % MOD;
                cur %= period;
            }
        }
        ans = (ans + cur) % MOD;
        if (fail) ans = -1;

        return ans;
    }
}

namespace solve2 {
    int n;
    vector<Edge> ed;
    vector<int> e[N];
    int p[N];

    void dfs(int v, int pr) {
        p[v] = pr;
        for (int id : e[v]) {
            if (id == pr) continue;
            dfs(ed[id].go(v), id);
        }
    }

    vector<int> getPath(int s, int f) {
        dfs(f, -1);
        vector<int> ans;
        for (int v = s; v != f; v = ed[p[v]].go(v)) {
            ans.push_back(p[v]);
        }
        return ans;
    }

    ll solve(int n, vector<Edge> _ed, vector<int> x, int s, int f) {
        ed = _ed;
        int k = x.size();

        for (int i = 0; i < n; i++) e[i].clear();
        for (int i = 0; i < n - 1; i++) {
            int u1 = ed[i].u1, u2 = ed[i].u2;
            e[u1].push_back(i);
            e[u2].push_back(i);
        }

        vector<vector<pair<ll, ll> > > banned(n - 1);
        ll period = 0;
        for (int i = 0; i < k; i++) {
            auto ids = getPath(x[i], x[(i + 1) % k]);
            for (int id : ids) {
                banned[id].push_back({ period - ed[id].d2 + 1, period + ed[id].d1 });
                period += ed[id].d1;
            }
        }
        for (int id = 0; id < n - 1; id++) {
            vector<pair<ll, ll> > vct;
            for (auto o : banned[id]) {
                if (o.first < 0) {
                    vct.push_back({ period + o.first, period });
                    o.first = 0;
                }
                if (o.second > period) {
                    vct.push_back({ 0, o.second - period });
                    o.second = period;
                }
                vct.push_back(o);
            }
            vector<pair<ll, int> > ev;
            for (auto o : vct) {
                ev.push_back({ o.first, -1 });
                ev.push_back({ o.second, +1 });
            }
            sort(ev.begin(), ev.end());
            banned[id].clear();
            int cnt = 0;
            ll fr = -1;
            for (auto o : ev) {
                if (cnt == 0 && o.second == -1) {
                    fr = o.first;
                }
                if (cnt == 1 && o.second == +1) {
                    banned[id].push_back({ fr, o.first });
                }
                cnt -= o.second;
            }
        }

        auto ids = getPath(s, f);

        bool fail = 0;
        ll cur = 0;
        for (auto id : ids) {
            ll started = cur;
            while (1) {
                if (cur - started >= period) {
                    fail = 1;
                    break;
                }
                int pos = lower_bound(banned[id].begin(), banned[id].end(), make_pair(cur % period + 1, -1LL)) - banned[id].begin() - 1;
                if (pos != -1 && pos != banned[id].size() && banned[id][pos].first <= cur % period && banned[id][pos].second > cur % period) {
                    cur = (cur - cur % period + banned[id][pos].second) % MOD;
                }
                else break;
            }
            if (fail) break;
            cur = (cur + ed[id].d2) % MOD;
        }
        if (fail) cur = -1;
        return cur;
    }
}

void stress() {
    for (int it = 17864;; it++) {
        srand(it);
        cout << "it: " << it << endl;

        int n = rand() % 9 + 2;
        int k = rand() % 9 + 2;
        if (n == 2 && k % 2 == 1) continue;
        vector<int> x(k);
        for (int i = 0; i < k; i++) {
            x[i] = rand() % n;
            while ((i > 0 && x[i] == x[i - 1]) || (i == k - 1 && x[i] == x[0])) {
                x[i] = rand() % n;
            }
        }
        int s = rand() % n;
        int f = rand() % n;
        while (f == s) f = rand() % n;
        vector<Edge> ed;
        for (int i = 1; i < n; i++) {
            ed.push_back({rand() % i, i, rand() % 100 + 1, rand() % 100 + 1});
        }

        cout << n << " " << k << endl;
        for (auto o : ed) cout << o.u1 << " " << o.u2 << " " << o.d1 << " " << o.d2 << endl;
        for (int o : x) cout << o << " "; cout << endl;
        cout << s << " " << f << endl;

        auto ans1 = solve1::solve(n, ed, x, s, f);
        auto ans2 = solve2::solve(n, ed, x, s, f);
        if (ans1 != ans2) {
            cout << ans1 << " instead of " << ans2 << endl;
            exit(0);
        }
    }
}

int main() {
#ifdef HOME
    freopen("in", "r", stdin);
#endif
    //stress();

    int T;
    scanf("%d", &T);
    while (T--) {
        int n, k;
        scanf("%d%d", &n, &k);
        vector<Edge> ed(n - 1);
        for (int i = 0; i < n - 1; i++) {
            int u1, u2, d1, d2;
            scanf("%d%d%d%d", &u1, &u2, &d1, &d2);
            u1--;
            u2--;
            ed[i] = Edge({u1, u2, d1, d2});
        }
        vector<int> x(k);
        for (int i = 0; i < k; i++) scanf("%d", &x[i]), x[i]--;
        int s, f;
        scanf("%d%d", &s, &f);
        s--; f--;
    
        printf("%d\n", solve1::solve(n, ed, x, s, f));
    }
    
    return 0;
}