#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
/**
 *    author:  [itmo] enot.1.10
 *    created: 14.01.2018 23:28:03       
**/
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef long double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;


ll mpow(ll a, ll b)
{
    ll res = 1;
    while (b)
    {
        if (b & 1) res *= a;
        a *= a;
        b >>= 1;
    }
    return res;
}

ll rev(ll a)
{
    return mpow(a, (unsigned long long)pw(63) - 1);
}

ll fact(ll n)
{
    ll N = 2 * n - 1;

    ll blocks = N >> 17;
    ll res = 1;
    for (ll i = blocks * pw(17) + 1; i <= N; i += 2) res = res * i;

    if (blocks)
    {
        ll A = 1;
        ll B = 0;
        for (ll i = 1; i < pw(16); i += 2)
        {
            A *= -i * i;
            B += rev(-i * i);
        }
        B *= A;
    
    
        ll sum = blocks * (4 * blocks * blocks - 1) * rev(3);
        ll ans = mpow(A, blocks) + mpow(A, blocks - 1) * sum * pw(32) * B;
        res *= ans;
    }
    return res;
}


ll calc(ll n)
{
    if (n == 1) return 1;
    return calc((n + 1) / 2) * fact((n + 1) / 2);
}


int main()
{
    #ifdef home
        assert(freopen("1.in", "r", stdin));
        assert(freopen("1.out", "w", stdout));
    #endif
    ll n;
    scanf(INT64, &n);

    ll res = calc(n);

    printf(UNS64 "\n", (unsigned long long)res);
        
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
