#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

int MOD;

int bin(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) res = 1LL * res * a % MOD;
        a = 1LL * a * a % MOD;
        n >>= 1;
    }
    return res;
}

int inv(int x) {
    return bin(x, MOD - 2);
}

ll h(const vector<int> &a) {
    ll res = 1;
    for (int x : a) {
        res = 19 * res + (x + 1);
    }
    return res;
}

void uni(int u, int v, vector<int> &p) {
    if (p[u] == -1 || p[v] == -1) return;
    int o = p[u];
    for (int &x : p) if (x == o) x = p[v];
}

void fix(vector<int> &p) {
    vector<int> a(2 * p.size(), -1);
    int cur = 0;
    for (int &x : p) {
        if (x != -1) {
            if (a[x] == -1) a[x] = cur++;
            x = a[x];
        }
    }
}

vector<int> berlekamp(vector<int> s) {
    int l = 0;
    vector<int> la(1, 1);
    vector<int> b(1, 1);
    for (int r = 1; r <= (int)s.size(); r++) {
        int delta = 0;
        for (int j = 0; j <= l; j++) {
            delta = (delta + 1LL * s[r - 1 - j] * la[j]) % MOD;
        }
        b.insert(b.begin(), 0);
        if (delta != 0) {
            vector<int> t(max(la.size(), b.size()));
            for (int i = 0; i < (int)t.size(); i++) {
                if (i < (int)la.size()) t[i] = (t[i] + la[i]) % MOD;
                if (i < (int)b.size()) t[i] = (t[i] - 1LL * delta * b[i] % MOD + MOD) % MOD;
            }
            if (2 * l <= r - 1) {
                b = la;
                int od = inv(delta);
                for (int &x : b) x = 1LL * x * od % MOD;
                l = r - l;
            }
            la = t;
        }
    }
    assert(la.size() == l + 1);
    assert(l * 2 + 30 < s.size());
    reverse(la.begin(), la.end());
    return la;
}



vector<int> mul(vector<int> a, vector<int> b) {
    vector<int> c(a.size() + b.size() - 1);
    for (int i = 0; i < (int)a.size(); i++) {
        for (int j = 0; j < (int)b.size(); j++) {
            c[i + j] = (c[i + j] + 1LL * a[i] * b[j]) % MOD;
        }
    }
    vector<int> res(c.size());
    for (int i = 0; i < (int)res.size(); i++) res[i] = c[i] % MOD;
    return res;
}

vector<int> mod(vector<int> a, vector<int> b) {
    if (a.size() < b.size()) a.resize(b.size() - 1);

    int o = inv(b.back());
    for (int i = (int)a.size() - 1; i >= b.size() - 1; i--) {
        if (a[i] == 0) continue;
        int coef = 1LL * o * (MOD - a[i]) % MOD;
        for (int j = 0; j < (int)b.size(); j++) {
            a[i - (int)b.size() + 1 + j] = (a[i - (int)b.size() + 1 + j] + 1LL * coef * b[j]) % MOD;
        }
    }
    while (a.size() >= b.size()) {
        assert(a.back() == 0);
        a.pop_back();
    }
    return a;
}

vector<int> bin(int n, vector<int> p) {
    vector<int> res(1, 1);
    vector<int> a(2); a[1] = 1;
    while (n) {
        if (n & 1) res = mod(mul(res, a), p);
        a = mod(mul(a, a), p);
        n >>= 1;
    }
    return res;
}

int solve(int n, int m, int _MOD) {
    MOD = _MOD;
    if (n == 1) {
        if (m == 1) return 2 % MOD;
        return 4 % MOD;
    }
    int states = 1;
    unordered_map<ll, int> mp;
    queue<vector<int> > q;
    mp[h(vector<int>(n, -1))] = states++;
    q.push(vector<int>(n, -1));
    vector<pair<int, int> > ed;

    vector<int> masks;
    for (int i = 0; i < (1 << n); i++) {
        bool ok = 1;
        for (int j = 0; j < n - 1; j++) {
            if ((i & (1 << j)) && (i & (1 << (j + 1)))) {
                ok = 0;
            }
        }
        if (ok) masks.push_back(i);
    }
    vector<vector<int> > masks2(masks.size());
    for (int i = 0; i < (int)masks.size(); i++) {
        for (int nmask : masks) {
            if (!(masks[i] & nmask)) {
                masks2[i].push_back(nmask);
            }
        }
    }
    masks2.push_back(masks);
    masks.push_back((1 << n) - 1);

    while (!q.empty()) {
        auto vct = q.front();
        q.pop();
        int fr = mp[h(vct)];
        int cmask = 0;
        for (int i = 0; i < n; i++) if (vct[i] == -1) cmask |= 1 << i;
        int id = lower_bound(masks.begin(), masks.end(), cmask) - masks.begin();
        assert(masks[id] == cmask);
        for (int mask : masks2[id]) {
            auto nvct = vct;
            for (int i = 0; i < n; i++) if (mask & (1 << i)) nvct.push_back(-1);
            else nvct.push_back(n + i);
            for (int i = 0; i < n; i++) {
                uni(i, i + n, nvct);
                if (i < n - 1) {
                    uni(i + n, i + 1 + n, nvct);
                }
            }
            vector<vector<int> > cnt(2, vector<int>(2 * n));
            for (int i = 0; i < 2 * n; i++) if (nvct[i] != -1) cnt[i / n][nvct[i]]++;
            bool ok = 1;
            for (int i = 0; i < 2 * n; i++) if (cnt[0][i] > 0 && cnt[1][i] == 0) ok = 0;
            if (!ok) continue;

            nvct.erase(nvct.begin(), nvct.begin() + n);
            fix(nvct);

            ll ch = h(nvct);
            if (!mp.count(ch)) {
                mp[ch] = states++;
                q.push(nvct);
            }
            ed.push_back({fr, mp[ch]});
        }
        set<int> st;
        for (int x : vct) if (x != -1) st.insert(x);
        if (st.size() == 1) {
            ed.push_back({fr, 0});
        }
    }
    //cerr << "states: " << states << ", edges: " << ed.size() << endl;
    sort(ed.begin(), ed.end());


    int prev = 900;
    int vals = 2 * prev + 100;
    vector<int> t;
    vector<int> dp(states);
    dp[1] = 1;
    for (int i = 0; i < vals + 1; i++) {
        vector<ll> ndp(states);
        for (auto o : ed) {
            ndp[o.second] += dp[o.first];
        }
        for (int j = 0; j < states; j++) dp[j] = ndp[j] % MOD;
        if (i > 0) t.push_back(dp[0]);
    }

    vector<int> v = berlekamp(t);
    cerr << "prev: " << v.size() << endl;
    //reverse(v.begin(), v.end());
    vector<int> o = bin(m - 1, v);
    int res = 0;
    for (int i = 0; i < (int)o.size(); i++) res = (res + 1LL * o[i] * t[i]) % MOD;
    return res;
}

int main() {
#ifdef HOME
    assert(freopen("in", "r", stdin));
#endif

    int n, m, _MOD;
    cin >> n >> m >> _MOD;
    cout << solve(n, m, _MOD) << endl;

    return 0;
}
