#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

mt19937 rnd;
int MOD = 998244353;
int ROOT;
const int K = 20;
const int N = 1 << K;

int bin(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) res = 1LL * res * a % MOD;
        a = 1LL * a * a % MOD;
        n >>= 1;
    }
    return res;
}

int inv(int x) {
    return bin(x, MOD - 2);
}

namespace fft {
#define forn(i, n) for (int i = 0; i < (n); i++)
    int root[N];
    int rev[N];

    void init() {
        ROOT = 2;
        while (!(bin(ROOT, N) == 1 && bin(ROOT, N / 2) != 1)) ROOT++;

        forn(i, N) rev[i] = (rev[i >> 1] >> 1) + ((i & 1) * (N / 2));
        int NN = N >> 1;
        int z = 1;
        forn(i, NN)
        {
            root[i + NN] = z;
            z = z * (ll)ROOT % MOD;
        }
        for (int i = NN - 1; i > 0; --i) root[i] = root[2 * i];
    }

    void fft(int *a, int *f) {
        forn(i, N) f[i] = a[rev[i]];
        for (int k = 1; k < N; k <<= 1) for (int i = 0; i < N; i += 2 * k) forn(j, k)
                {
                    int z = f[i + j + k] * (ll)root[j + k] % MOD;
                    f[i + j + k] = (f[i + j] - z + MOD) % MOD;
                    f[i + j] = (f[i + j] + z) % MOD;
                }
    }

    int A[N], B[N], C[N];
    int F[N], G[N];

    void _mult() {
        fft(A, F);
        fft(B, G);
        int invN = inv(N);
        forn(i, N) A[i] = F[i] * (ll)G[i] % MOD * invN % MOD;
        reverse(A + 1, A + N);
        fft(A, C);
    }

    void mult(int n1, int n2) {
        for (int i = n1; i < N; ++i) A[i] = 0;
        for (int i = n2; i < N; ++i) B[i] = 0;
        _mult();
    }
}

bool isPrime(int x) {
    for (int i = 2; i * i <= x; i++) if (x % i == 0) return 0;
    return 1;
}

int n, m, c;
int p[N], s[N], col[N];

void randomShuffle() {
    map<int, int> mp;
    for (int i = 0; i < m; i++) {
        if (!mp.count(s[i])) {
            mp[s[i]] = rnd() % (MOD - 1) + 1;
        }
        s[i] = mp[s[i]];
    }
}

int main() {
#ifdef HOME
    freopen("in", "r", stdin);
#endif

    scanf("%d%d%d", &n, &m, &c);
    for (int i = 0; i < n; i++) {
        scanf("%d", &p[i]);
        p[i]--;
    }
    for (int i = 0; i < m; i++) {
        scanf("%d", &s[i]);
        s[i]--;
    }
    int cur = 1;
    vector<int> frst(1), len(1);
    for (int i = 0; i < n; i++) {
        if (col[i] != 0) continue;
        frst.push_back(i);
        int clen = 0;
        for (int x = i; col[x] == 0; x = p[x]) {
            col[x] = cur;
            clen++;
        }
        len.push_back(clen);
        cur++;
    }

    vector<char> ans(m - n + 1, 1);


    for (int it = 0; it < 1; it++) {
        randomShuffle();
        fft::init();

        int q;
        while (1) {
            q = rnd() % MOD;
            bool ok = 1;
            for (int x = 2; x * x <= MOD - 1; x++) {
                if ((MOD - 1) % x) continue;
                ok &= bin(q, (MOD - 1) / x) != 1;
                ok &= bin(q, x) != 1;
            }
            if (ok) break;
        }
        vector<int> pw(cur);
        pw[0] = 1;
        for (int i = 1; i < cur; i++) pw[i] = 1LL * pw[i - 1] * q % MOD;

        for (int i = 0; i < m; i++) {
            fft::A[i] = s[i];
        }
        for (int i = 0; i < n; i++) {
            int x;
            if (i == frst[col[i]]) x = 1LL * (MOD - (len[col[i]] - 1)) * pw[col[i]] % MOD;
            else x = pw[col[i]];
            fft::B[n - 1 - i] = x;
        }
        fft::mult(m, n);
        for (int i = 0; i <= m - n; i++) {
            ans[i] &= fft::C[n - 1 + i] == 0;
        }
        MOD += N;
        while (!isPrime(MOD)) MOD += N;
    }
    string res = "";
    for (int i = 0; i <= m - n; i++) res += (char)('0' + ans[i]);
    cout << res << endl;

    int sum = 0;
    for (char x : ans) sum += x;
    cerr << "sum: " << sum << endl;

    return 0;
}
