#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
/**
 *    author:  [itmo] enot.1.10
 *    created: 14.01.2018 23:28:03       
**/
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef long double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;


const int mod = (int)1e9 + 7;

int mpow(int a, int b, int m = mod)
{
    int res = 1;
    while (b)
    {
        if (b & 1) res = (res * (ll)a) % m;
        a = (a * (ll)a) % m;
        b >>= 1;
    }
    return res;
}



int getPQ(ll n) // new x = x - x*x/4
{
    int rev4 = mpow(4, mod - 2);

    vi v;
    int x = 1;
    set<int> s;
    while (1)
    {
        v.pb(x);
        s.insert(x);
        x = (x + mod - x * (ll)x % mod * rev4 % mod) % mod;
        if (s.find(x) != s.end()) break;
    }
    int pos = -1;
    forn(i, sz(v)) if (v[i] == x) pos = i;
    
    int pred = pos;
    int period = sz(v) - pos;

    n--;
    
    if (n < pred) return v[(int)n];
    
    int ansPos = (n - pred) % period + pred;
    return v[ansPos];
}

int getPhi(int m)
{
    int r = m;
    for (int i = 2; i * i <= m; ++i) if (m % i == 0)
    {
        r = r / i * (i - 1);
        while (m % i == 0) m /= i;
    }
    if (m > 1) r = r / m * (m - 1);
    return r;
}


int getQ(ll n) // calc pow(2, pow(2, n) - 2) % mod
{
    int phi = getPhi(mod - 1);
    int z = n % phi;
    int a = (mpow(2, z, mod - 1) + mod - 3) % (mod - 1);
    return mpow(2, a, mod);
}

int main()
{
    #ifdef home
        assert(freopen("1.in", "r", stdin));
        assert(freopen("1.out", "w", stdout));
    #endif
    ll n;
    scanf(INT64, &n);
    
    int PQ = getPQ(n);
    int Q = getQ(n);

    int P = PQ * (ll)Q % mod;

    printf("%d %d\n", P, Q);
        
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
